--- v5
+++ v3
@@ -4,11 +4,7 @@
By using a relative path instead of an absolute path, we can move the
superproject directory around on the filesystem without breaking the
-submodule's cache. And by using the path from gitdir to gitdir, we can
-move the submodule within the superproject's tree structure without
-breaking the submodule's cache, too. Finally, by pointing at
-"get_git_common_dir()" instead of "get_git_dir()", we ensure the link
-will refer to the parent repo, not to a specific worktree.
+submodule's cache.
Since this hint value is only introduced during new submodule creation
via `git submodule add`, though, there is more work to do to allow the
@@ -23,76 +19,81 @@
Signed-off-by: Emily Shaffer <emilyshaffer@google.com>
Helped-by: Junio C Hamano <gitster@pobox.com>
---
- Documentation/config/submodule.txt | 12 +++++++++++
- builtin/submodule--helper.c | 4 ++++
- t/t7400-submodule-basic.sh | 32 ++++++++++++++++++++----------
- 3 files changed, 38 insertions(+), 10 deletions(-)
+ Documentation/config/submodule.txt | 15 +++++++++++
+ builtin/submodule--helper.c | 4 +++
+ t/t7400-submodule-basic.sh | 40 ++++++++++++++++--------------
+ 3 files changed, 41 insertions(+), 18 deletions(-)
diff --git a/Documentation/config/submodule.txt b/Documentation/config/submodule.txt
-index ee454f8126..8cc57fe1c1 100644
+index d7a63c8c12..23e0a01d90 100644
--- a/Documentation/config/submodule.txt
+++ b/Documentation/config/submodule.txt
-@@ -91,3 +91,15 @@ submodule.alternateErrorStrategy::
+@@ -90,3 +90,18 @@ submodule.alternateErrorStrategy::
`ignore`, `info`, `die`. Default is `die`. Note that if set to `ignore`
or `info`, and if there is an error with the computed alternate, the
clone proceeds as if no alternate was specified.
+
+submodule.superprojectGitDir::
-+ The relative path from the submodule's gitdir to its superproject's
-+ common dir. When Git is run in a repository, it usually makes no
-+ difference whether this repository is standalone or a submodule, but if
-+ this configuration variable is present, additional behavior may be
-+ possible, such as "git status" printing additional information about
-+ this submodule's status with respect to its superproject. This config
-+ should only be present in projects which are submodules, but is not
-+ guaranteed to be present in every submodule, so only optional
-+ value-added behavior should be linked to it. It is set automatically
-+ during submodule creation.
++ The relative path from the submodule's worktree to its superproject's
++ gitdir. When Git is run in a repository, it usually makes no difference
++ whether this repository is standalone or a submodule, but if this
++ configuration variable is present, additional behavior may be possible,
++ such as "git status" printing additional information about this
++ submodule's status with respect to its superproject. This config should
++ only be present in projects which are submodules, but is not guaranteed
++ to be present in every submodule, so only optional value-added behavior
++ should be linked to it. It is set automatically during
++ submodule creation.
+++
++ Because of this configuration variable, it is forbidden to use the
++ same submodule worktree shared by multiple superprojects.
diff --git a/builtin/submodule--helper.c b/builtin/submodule--helper.c
-index 6298cbdd4e..f803812225 100644
+index d55f6262e9..d60fcd2c7d 100644
--- a/builtin/submodule--helper.c
+++ b/builtin/submodule--helper.c
-@@ -1838,6 +1838,10 @@ static int clone_submodule(struct module_clone_data *clone_data)
+@@ -1910,6 +1910,10 @@ static int module_clone(int argc, const char **argv, const char *prefix)
git_config_set_in_file(p, "submodule.alternateErrorStrategy",
- error_strategy);
+ error_strategy);
+ git_config_set_in_file(p, "submodule.superprojectGitdir",
-+ relative_path(absolute_path(get_git_common_dir()),
-+ sm_gitdir, &sb));
++ relative_path(absolute_path(get_git_dir()),
++ path, &sb));
+
free(sm_alternate);
free(error_strategy);
diff --git a/t/t7400-submodule-basic.sh b/t/t7400-submodule-basic.sh
-index d69a5c0032..3c20d42fbe 100755
+index 4bc6b6c886..e407329d81 100755
--- a/t/t7400-submodule-basic.sh
+++ b/t/t7400-submodule-basic.sh
-@@ -109,12 +109,24 @@ submodurl=$(pwd -P)
+@@ -108,14 +108,18 @@ test_expect_success 'setup - repository to add submodules to' '
+ submodurl=$(pwd -P)
inspect() {
- sub_dir=$1 &&
+- dir=$1 &&
+-
+- git -C "$dir" for-each-ref --format='%(refname)' 'refs/heads/*' >heads &&
+- { git -C "$dir" symbolic-ref HEAD || :; } >head &&
+- git -C "$dir" rev-parse HEAD >head-sha1 &&
+- git -C "$dir" update-index --refresh &&
+- git -C "$dir" diff-files --exit-code &&
+- git -C "$dir" clean -n -d -x >untracked
++ sub_dir=$1 &&
+ super_dir=$2 &&
-
- git -C "$sub_dir" for-each-ref --format='%(refname)' 'refs/heads/*' >heads &&
- { git -C "$sub_dir" symbolic-ref HEAD || :; } >head &&
- git -C "$sub_dir" rev-parse HEAD >head-sha1 &&
- git -C "$sub_dir" update-index --refresh &&
- git -C "$sub_dir" diff-files --exit-code &&
+
-+ # Ensure that submodule.superprojectGitDir contains the path from the
-+ # submodule's gitdir to the superproject's gitdir.
-+
-+ super_abs_gitdir=$(git -C "$super_dir" rev-parse --path-format=absolute --git-common-dir) &&
-+ sub_abs_gitdir=$(git -C "$sub_dir" rev-parse --path-format=absolute --git-common-dir) &&
-+
-+ [ "$(git -C "$sub_dir" config --get submodule.superprojectGitDir)" = \
-+ "$(test-tool path-utils relative_path "$super_abs_gitdir" \
-+ "$sub_abs_gitdir")" ] &&
-+
- git -C "$sub_dir" clean -n -d -x >untracked
++ git -C "$sub_dir" for-each-ref --format='%(refname)' 'refs/heads/*' >heads &&
++ { git -C "$sub_dir" symbolic-ref HEAD || :; } >head &&
++ git -C "$sub_dir" rev-parse HEAD >head-sha1 &&
++ git -C "$sub_dir" update-index --refresh &&
++ git -C "$sub_dir" diff-files --exit-code &&
++ cached_super_dir="$(git -C "$sub_dir" config --get submodule.superprojectGitDir)" &&
++ [ "$(git -C "$super_dir" rev-parse --absolute-git-dir)" \
++ -ef "$sub_dir/$cached_super_dir" ] &&
++ git -C "$sub_dir" clean -n -d -x >untracked
}
-@@ -138,7 +150,7 @@ test_expect_success 'submodule add' '
+ test_expect_success 'submodule add' '
+@@ -138,7 +142,7 @@ test_expect_success 'submodule add' '
) &&
rm -f heads head untracked &&
@@ -101,7 +102,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -240,7 +252,7 @@ test_expect_success 'submodule add --branch' '
+@@ -229,7 +233,7 @@ test_expect_success 'submodule add --branch' '
) &&
rm -f heads head untracked &&
@@ -110,7 +111,7 @@
test_cmp expect-heads heads &&
test_cmp expect-head head &&
test_must_be_empty untracked
-@@ -256,7 +268,7 @@ test_expect_success 'submodule add with ./ in path' '
+@@ -245,7 +249,7 @@ test_expect_success 'submodule add with ./ in path' '
) &&
rm -f heads head untracked &&
@@ -119,7 +120,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -272,7 +284,7 @@ test_expect_success 'submodule add with /././ in path' '
+@@ -261,7 +265,7 @@ test_expect_success 'submodule add with /././ in path' '
) &&
rm -f heads head untracked &&
@@ -128,7 +129,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -288,7 +300,7 @@ test_expect_success 'submodule add with // in path' '
+@@ -277,7 +281,7 @@ test_expect_success 'submodule add with // in path' '
) &&
rm -f heads head untracked &&
@@ -137,7 +138,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -304,7 +316,7 @@ test_expect_success 'submodule add with /.. in path' '
+@@ -293,7 +297,7 @@ test_expect_success 'submodule add with /.. in path' '
) &&
rm -f heads head untracked &&
@@ -146,7 +147,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -320,7 +332,7 @@ test_expect_success 'submodule add with ./, /.. and // in path' '
+@@ -309,7 +313,7 @@ test_expect_success 'submodule add with ./, /.. and // in path' '
) &&
rm -f heads head untracked &&
@@ -155,7 +156,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -351,7 +363,7 @@ test_expect_success 'submodule add in subdirectory' '
+@@ -340,7 +344,7 @@ test_expect_success 'submodule add in subdirectory' '
) &&
rm -f heads head untracked &&
@@ -164,7 +165,7 @@
test_cmp expect heads &&
test_cmp expect head &&
test_must_be_empty untracked
-@@ -492,7 +504,7 @@ test_expect_success 'update should work when path is an empty dir' '
+@@ -481,7 +485,7 @@ test_expect_success 'update should work when path is an empty dir' '
git submodule update -q >update.out &&
test_must_be_empty update.out &&
@@ -173,7 +174,7 @@
test_cmp expect head-sha1
'
-@@ -551,7 +563,7 @@ test_expect_success 'update should checkout rev1' '
+@@ -540,7 +544,7 @@ test_expect_success 'update should checkout rev1' '
echo "$rev1" >expect &&
git submodule update init &&
@@ -183,5 +184,5 @@
test_cmp expect head-sha1
'
--
-2.34.0.rc0.344.g81b53c2807-goog
+2.33.0.rc2.250.ged5fa647cd-goog